/*
  File autogenerated by gengetopt version 2.19.1
  generated with the following command:
  gengetopt -uCOMMAND --set-version=0.4 

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "getopt.h"

#include "cmdline.h"

const char *gengetopt_args_info_purpose = "";

const char *gengetopt_args_info_usage = "Usage: untie [OPTIONS]... [COMMAND]...";

const char *gengetopt_args_info_description = "";

const char *gengetopt_args_info_help[] = {
  "  -h, --help                  Print help and exit",
  "  -V, --version               Print version and exit",
  "      --mount                 New mount namespace  (default=off)",
  "      --uname                 New uname  (default=off)",
  "      --ipc                   New IPC context  (default=off)",
  "      --userns                New user namespace  (default=off)",
  "      --pidns                 New PID namespace  (default=off)",
  "      --netns                 New network namespace  (default=off)",
  "      --mask=MASK             Pass user defined flag",
  "      --chroot=DIRECTORY      Chroot in the specified directory",
  "      --uid=UID               Change to the specified UID",
  "      --username=USERNAME     Change to the specified username",
  "      --gid=GID               Add the specified GID",
  "      --groupname=GROUP       Add the specified group",
  "      --daemonize             Run as daemon  (default=off)",
  "      --alarm=SECONDS         Set an alarm after the specified delay",
  "      --nice=NICE             Run as the specified nice level",
  "      --sched=SCHED           Use the specified (possibly RT) scheduling policy",
  "      --schedprio=PRIO        Set the priority according to the given scheduler",
  "      --timeout-term=SECONDS  Delay before sending a SIGTERM to the process",
  "      --timeout-kill=SECONDS  Delay before sending a SIGKILL to the process",
    0
};

static
void clear_given (struct gengetopt_args_info *args_info);
static
void clear_args (struct gengetopt_args_info *args_info);

static int
cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error);

static int
cmdline_parser_required2 (struct gengetopt_args_info *args_info, const char *prog_name, const char *additional_error);

struct int_list
{
  int arg;
  char *orig;
  struct int_list * next;
};

struct string_list
{
  char * arg;
  char *orig;
  struct string_list * next;
};

static char *
gengetopt_strdup (const char *s);

static
void clear_given (struct gengetopt_args_info *args_info)
{
  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->mount_given = 0 ;
  args_info->uname_given = 0 ;
  args_info->ipc_given = 0 ;
  args_info->userns_given = 0 ;
  args_info->pidns_given = 0 ;
  args_info->netns_given = 0 ;
  args_info->mask_given = 0 ;
  args_info->chroot_given = 0 ;
  args_info->uid_given = 0 ;
  args_info->username_given = 0 ;
  args_info->gid_given = 0 ;
  args_info->groupname_given = 0 ;
  args_info->daemonize_given = 0 ;
  args_info->alarm_given = 0 ;
  args_info->nice_given = 0 ;
  args_info->sched_given = 0 ;
  args_info->schedprio_given = 0 ;
  args_info->timeout_term_given = 0 ;
  args_info->timeout_kill_given = 0 ;
}

static
void clear_args (struct gengetopt_args_info *args_info)
{
  args_info->mount_flag = 0;
  args_info->uname_flag = 0;
  args_info->ipc_flag = 0;
  args_info->userns_flag = 0;
  args_info->pidns_flag = 0;
  args_info->netns_flag = 0;
  args_info->mask_arg = NULL;
  args_info->mask_orig = NULL;
  args_info->chroot_arg = NULL;
  args_info->chroot_orig = NULL;
  args_info->uid_orig = NULL;
  args_info->username_arg = NULL;
  args_info->username_orig = NULL;
  args_info->gid_arg = NULL;
  args_info->gid_orig = NULL;
  args_info->groupname_arg = NULL;
  args_info->groupname_orig = NULL;
  args_info->daemonize_flag = 0;
  args_info->alarm_orig = NULL;
  args_info->nice_orig = NULL;
  args_info->sched_arg = NULL;
  args_info->sched_orig = NULL;
  args_info->schedprio_orig = NULL;
  args_info->timeout_term_orig = NULL;
  args_info->timeout_kill_orig = NULL;
  
}

static
void init_args_info(struct gengetopt_args_info *args_info)
{
  args_info->help_help = gengetopt_args_info_help[0] ;
  args_info->version_help = gengetopt_args_info_help[1] ;
  args_info->mount_help = gengetopt_args_info_help[2] ;
  args_info->uname_help = gengetopt_args_info_help[3] ;
  args_info->ipc_help = gengetopt_args_info_help[4] ;
  args_info->userns_help = gengetopt_args_info_help[5] ;
  args_info->pidns_help = gengetopt_args_info_help[6] ;
  args_info->netns_help = gengetopt_args_info_help[7] ;
  args_info->mask_help = gengetopt_args_info_help[8] ;
  args_info->mask_min = -1;
  args_info->mask_max = -1;
  args_info->chroot_help = gengetopt_args_info_help[9] ;
  args_info->uid_help = gengetopt_args_info_help[10] ;
  args_info->username_help = gengetopt_args_info_help[11] ;
  args_info->gid_help = gengetopt_args_info_help[12] ;
  args_info->gid_min = -1;
  args_info->gid_max = -1;
  args_info->groupname_help = gengetopt_args_info_help[13] ;
  args_info->groupname_min = -1;
  args_info->groupname_max = -1;
  args_info->daemonize_help = gengetopt_args_info_help[14] ;
  args_info->alarm_help = gengetopt_args_info_help[15] ;
  args_info->nice_help = gengetopt_args_info_help[16] ;
  args_info->sched_help = gengetopt_args_info_help[17] ;
  args_info->schedprio_help = gengetopt_args_info_help[18] ;
  args_info->timeout_term_help = gengetopt_args_info_help[19] ;
  args_info->timeout_kill_help = gengetopt_args_info_help[20] ;
  
}

void
cmdline_parser_print_version (void)
{
  printf ("%s %s\n", CMDLINE_PARSER_PACKAGE, CMDLINE_PARSER_VERSION);
}

void
cmdline_parser_print_help (void)
{
  int i = 0;
  cmdline_parser_print_version ();

  if (strlen(gengetopt_args_info_purpose) > 0)
    printf("\n%s\n", gengetopt_args_info_purpose);

  printf("\n%s\n\n", gengetopt_args_info_usage);

  if (strlen(gengetopt_args_info_description) > 0)
    printf("%s\n", gengetopt_args_info_description);

  while (gengetopt_args_info_help[i])
    printf("%s\n", gengetopt_args_info_help[i++]);
}

void
cmdline_parser_init (struct gengetopt_args_info *args_info)
{
  clear_given (args_info);
  clear_args (args_info);
  init_args_info (args_info);

  args_info->inputs = NULL;
  args_info->inputs_num = 0;
}

static void
cmdline_parser_release (struct gengetopt_args_info *args_info)
{
  
  unsigned int i;
  if (args_info->mask_arg)
    {
      for (i = 0; i < args_info->mask_given; ++i)
        {
          if (args_info->mask_orig [i])
            {
              free (args_info->mask_orig [i]); /* free previous argument */
              args_info->mask_orig [i] = 0;
            }
        }
      free (args_info->mask_arg); /* free previous argument */
      args_info->mask_arg = 0;
      free (args_info->mask_orig); /* free previous argument */
      args_info->mask_orig = 0;
    }
  if (args_info->chroot_arg)
    {
      free (args_info->chroot_arg); /* free previous argument */
      args_info->chroot_arg = 0;
    }
  if (args_info->chroot_orig)
    {
      free (args_info->chroot_orig); /* free previous argument */
      args_info->chroot_orig = 0;
    }
  if (args_info->uid_orig)
    {
      free (args_info->uid_orig); /* free previous argument */
      args_info->uid_orig = 0;
    }
  if (args_info->username_arg)
    {
      free (args_info->username_arg); /* free previous argument */
      args_info->username_arg = 0;
    }
  if (args_info->username_orig)
    {
      free (args_info->username_orig); /* free previous argument */
      args_info->username_orig = 0;
    }
  if (args_info->gid_arg)
    {
      for (i = 0; i < args_info->gid_given; ++i)
        {
          if (args_info->gid_orig [i])
            {
              free (args_info->gid_orig [i]); /* free previous argument */
              args_info->gid_orig [i] = 0;
            }
        }
      free (args_info->gid_arg); /* free previous argument */
      args_info->gid_arg = 0;
      free (args_info->gid_orig); /* free previous argument */
      args_info->gid_orig = 0;
    }
  if (args_info->groupname_arg)
    {
      for (i = 0; i < args_info->groupname_given; ++i)
        {
          if (args_info->groupname_arg [i])
            {
              free (args_info->groupname_arg [i]); /* free previous argument */
              args_info->groupname_arg [i] = 0;
            }
          if (args_info->groupname_orig [i])
            {
              free (args_info->groupname_orig [i]); /* free previous argument */
              args_info->groupname_orig [i] = 0;
            }
        }
      if (args_info->groupname_arg [0])
        free (args_info->groupname_arg [0]); /* free default string */
      free (args_info->groupname_arg); /* free previous argument */
      args_info->groupname_arg = 0;
      free (args_info->groupname_orig); /* free previous argument */
      args_info->groupname_orig = 0;
    }
  if (args_info->alarm_orig)
    {
      free (args_info->alarm_orig); /* free previous argument */
      args_info->alarm_orig = 0;
    }
  if (args_info->nice_orig)
    {
      free (args_info->nice_orig); /* free previous argument */
      args_info->nice_orig = 0;
    }
  if (args_info->sched_arg)
    {
      free (args_info->sched_arg); /* free previous argument */
      args_info->sched_arg = 0;
    }
  if (args_info->sched_orig)
    {
      free (args_info->sched_orig); /* free previous argument */
      args_info->sched_orig = 0;
    }
  if (args_info->schedprio_orig)
    {
      free (args_info->schedprio_orig); /* free previous argument */
      args_info->schedprio_orig = 0;
    }
  if (args_info->timeout_term_orig)
    {
      free (args_info->timeout_term_orig); /* free previous argument */
      args_info->timeout_term_orig = 0;
    }
  if (args_info->timeout_kill_orig)
    {
      free (args_info->timeout_kill_orig); /* free previous argument */
      args_info->timeout_kill_orig = 0;
    }
  
  for (i = 0; i < args_info->inputs_num; ++i)
    free (args_info->inputs [i]);
  
  if (args_info->inputs_num)
    free (args_info->inputs);
  
  clear_given (args_info);
}

int
cmdline_parser_file_save(const char *filename, struct gengetopt_args_info *args_info)
{
  FILE *outfile;
  int i = 0;

  outfile = fopen(filename, "w");

  if (!outfile)
    {
      fprintf (stderr, "%s: cannot open file for writing: %s\n", CMDLINE_PARSER_PACKAGE, filename);
      return EXIT_FAILURE;
    }

  if (args_info->help_given) {
    fprintf(outfile, "%s\n", "help");
  }
  if (args_info->version_given) {
    fprintf(outfile, "%s\n", "version");
  }
  if (args_info->mount_given) {
    fprintf(outfile, "%s\n", "mount");
  }
  if (args_info->uname_given) {
    fprintf(outfile, "%s\n", "uname");
  }
  if (args_info->ipc_given) {
    fprintf(outfile, "%s\n", "ipc");
  }
  if (args_info->userns_given) {
    fprintf(outfile, "%s\n", "userns");
  }
  if (args_info->pidns_given) {
    fprintf(outfile, "%s\n", "pidns");
  }
  if (args_info->netns_given) {
    fprintf(outfile, "%s\n", "netns");
  }
  if (args_info->mask_orig)
    {
      for (i = 0; i < args_info->mask_given; ++i)
        {
          if (args_info->mask_orig [i])
            {
              fprintf(outfile, "%s=\"%s\"\n", "mask", args_info->mask_orig [i]);
            }
        }
    }
  if (args_info->chroot_given) {
    if (args_info->chroot_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "chroot", args_info->chroot_orig);
    } else {
      fprintf(outfile, "%s\n", "chroot");
    }
  }
  if (args_info->uid_given) {
    if (args_info->uid_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "uid", args_info->uid_orig);
    } else {
      fprintf(outfile, "%s\n", "uid");
    }
  }
  if (args_info->username_given) {
    if (args_info->username_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "username", args_info->username_orig);
    } else {
      fprintf(outfile, "%s\n", "username");
    }
  }
  if (args_info->gid_orig)
    {
      for (i = 0; i < args_info->gid_given; ++i)
        {
          if (args_info->gid_orig [i])
            {
              fprintf(outfile, "%s=\"%s\"\n", "gid", args_info->gid_orig [i]);
            }
        }
    }
  if (args_info->groupname_orig)
    {
      for (i = 0; i < args_info->groupname_given; ++i)
        {
          if (args_info->groupname_orig [i])
            {
              fprintf(outfile, "%s=\"%s\"\n", "groupname", args_info->groupname_orig [i]);
            }
        }
    }
  if (args_info->daemonize_given) {
    fprintf(outfile, "%s\n", "daemonize");
  }
  if (args_info->alarm_given) {
    if (args_info->alarm_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "alarm", args_info->alarm_orig);
    } else {
      fprintf(outfile, "%s\n", "alarm");
    }
  }
  if (args_info->nice_given) {
    if (args_info->nice_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "nice", args_info->nice_orig);
    } else {
      fprintf(outfile, "%s\n", "nice");
    }
  }
  if (args_info->sched_given) {
    if (args_info->sched_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "sched", args_info->sched_orig);
    } else {
      fprintf(outfile, "%s\n", "sched");
    }
  }
  if (args_info->schedprio_given) {
    if (args_info->schedprio_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "schedprio", args_info->schedprio_orig);
    } else {
      fprintf(outfile, "%s\n", "schedprio");
    }
  }
  if (args_info->timeout_term_given) {
    if (args_info->timeout_term_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "timeout-term", args_info->timeout_term_orig);
    } else {
      fprintf(outfile, "%s\n", "timeout-term");
    }
  }
  if (args_info->timeout_kill_given) {
    if (args_info->timeout_kill_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "timeout-kill", args_info->timeout_kill_orig);
    } else {
      fprintf(outfile, "%s\n", "timeout-kill");
    }
  }
  
  fclose (outfile);

  i = EXIT_SUCCESS;
  return i;
}

void
cmdline_parser_free (struct gengetopt_args_info *args_info)
{
  cmdline_parser_release (args_info);
}


/* gengetopt_strdup() */
/* strdup.c replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = NULL;
  if (!s)
    return result;

  result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

static char *
get_multiple_arg_token(const char *arg)
{
  char *tok, *ret;
  size_t len, num_of_escape;
  int i, j;

  if (!arg)
    return NULL;

  tok = strchr (arg, ',');
  num_of_escape = 0;

  /* make sure it is not escaped */
  while (tok)
    {
      if (*(tok-1) == '\\')
        {
          /* find the next one */
          tok = strchr (tok+1, ',');
          ++num_of_escape;
        }
      else
        break;
    }

  if (tok)
    len = (size_t)(tok - arg + 1);
  else
    len = strlen (arg) + 1;

  len -= num_of_escape;

  ret = (char *) malloc (len);

  i = 0;
  j = 0;
  while (arg[i] && (j < len-1))
    {
      if (arg[i] == '\\')
        ++i;

      ret[j++] = arg[i++];
    }

  ret[len-1] = '\0';

  return ret;
}

static char *
get_multiple_arg_token_next(const char *arg)
{
  char *tok;

  if (!arg)
    return NULL;

  tok = strchr (arg, ',');

  /* make sure it is not escaped */
  while (tok)
    {
      if (*(tok-1) == '\\')
        {
          /* find the next one */
          tok = strchr (tok+1, ',');
        }
      else
        break;
    }

  if (! tok || strlen(tok) == 1)
    return 0;

  return tok+1;
}

static int
check_multiple_option_occurrences(const char *prog_name, unsigned int option_given, int min, int max, const char *option_desc);

int
check_multiple_option_occurrences(const char *prog_name, unsigned int option_given, int min, int max, const char *option_desc)
{
  int error = 0;

  if (option_given && ! (min < 0 && max < 0))
    {
      if (min >= 0 && max >= 0)
        {
          if (min == max)
            {
              /* specific occurrences */
              if (option_given != min)
                {
                  fprintf (stderr, "%s: %s option occurrences must be %d\n",
                    prog_name, option_desc, min);
                  error = 1;
                }
            }
          else if (option_given < min
              || option_given > max)
            {
              /* range occurrences */
              fprintf (stderr, "%s: %s option occurrences must be between %d and %d\n",
                prog_name, option_desc, min, max);
              error = 1;
            }
        }
      else if (min >= 0)
        {
          /* at least check */
          if (option_given < min)
            {
              fprintf (stderr, "%s: %s option occurrences must be at least %d\n",
                prog_name, option_desc, min);
              error = 1;
            }
        }
      else if (max >= 0)
        {
          /* at most check */
          if (option_given > max)
            {
              fprintf (stderr, "%s: %s option occurrences must be at most %d\n",
                prog_name, option_desc, max);
              error = 1;
            }
        }
    }
    
  return error;
}
int
cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info)
{
  return cmdline_parser2 (argc, argv, args_info, 0, 1, 1);
}

int
cmdline_parser2 (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required)
{
  int result;

  result = cmdline_parser_internal (argc, argv, args_info, override, initialize, check_required, NULL);

  if (result == EXIT_FAILURE)
    {
      cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
cmdline_parser_required (struct gengetopt_args_info *args_info, const char *prog_name)
{
  int result = EXIT_SUCCESS;

  if (cmdline_parser_required2(args_info, prog_name, NULL) > 0)
    result = EXIT_FAILURE;

  if (result == EXIT_FAILURE)
    {
      cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
cmdline_parser_required2 (struct gengetopt_args_info *args_info, const char *prog_name, const char *additional_error)
{
  int error = 0;

  /* checks for required options */
  if (check_multiple_option_occurrences(prog_name, args_info->mask_given, args_info->mask_min, args_info->mask_max, "'--mask'"))
     error = 1;
  
  if (check_multiple_option_occurrences(prog_name, args_info->gid_given, args_info->gid_min, args_info->gid_max, "'--gid'"))
     error = 1;
  
  if (check_multiple_option_occurrences(prog_name, args_info->groupname_given, args_info->groupname_min, args_info->groupname_max, "'--groupname'"))
     error = 1;
  
  
  /* checks for dependences among options */

  return error;
}

int
cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error)
{
  int c;	/* Character of the parsed option.  */
  char *multi_token, *multi_next; /* for multiple options */

  int i;        /* Counter */

  struct int_list * mask_list = NULL,* mask_new = NULL;
  struct int_list * gid_list = NULL,* gid_new = NULL;
  struct string_list * groupname_list = NULL,* groupname_new = NULL;
  int error = 0;
  struct gengetopt_args_info local_args_info;

  if (initialize)
    cmdline_parser_init (args_info);

  cmdline_parser_init (&local_args_info);

  optarg = 0;
  optind = 0;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      char *stop_char;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "mount",	0, NULL, 0 },
        { "uname",	0, NULL, 0 },
        { "ipc",	0, NULL, 0 },
        { "userns",	0, NULL, 0 },
        { "pidns",	0, NULL, 0 },
        { "netns",	0, NULL, 0 },
        { "mask",	1, NULL, 0 },
        { "chroot",	1, NULL, 0 },
        { "uid",	1, NULL, 0 },
        { "username",	1, NULL, 0 },
        { "gid",	1, NULL, 0 },
        { "groupname",	1, NULL, 0 },
        { "daemonize",	0, NULL, 0 },
        { "alarm",	1, NULL, 0 },
        { "nice",	1, NULL, 0 },
        { "sched",	1, NULL, 0 },
        { "schedprio",	1, NULL, 0 },
        { "timeout-term",	1, NULL, 0 },
        { "timeout-kill",	1, NULL, 0 },
        { NULL,	0, NULL, 0 }
      };

      stop_char = 0;
      c = getopt_long (argc, argv, "hV", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          cmdline_parser_print_help ();
          cmdline_parser_free (&local_args_info);
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
          cmdline_parser_print_version ();
          cmdline_parser_free (&local_args_info);
          exit (EXIT_SUCCESS);


        case 0:	/* Long option with no short option */
          /* New mount namespace.  */
          if (strcmp (long_options[option_index].name, "mount") == 0)
          {
            if (local_args_info.mount_given)
              {
                fprintf (stderr, "%s: `--mount' option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
                goto failure;
              }
            if (args_info->mount_given && ! override)
              continue;
            local_args_info.mount_given = 1;
            args_info->mount_given = 1;
            args_info->mount_flag = !(args_info->mount_flag);
          }
          /* New uname.  */
          else if (strcmp (long_options[option_index].name, "uname") == 0)
          {
            if (local_args_info.uname_given)
              {
                fprintf (stderr, "%s: `--uname' option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
                goto failure;
              }
            if (args_info->uname_given && ! override)
              continue;
            local_args_info.uname_given = 1;
            args_info->uname_given = 1;
            args_info->uname_flag = !(args_info->uname_flag);
          }
          /* New IPC context.  */
          else if (strcmp (long_options[option_index].name, "ipc") == 0)
          {
            if (local_args_info.ipc_given)
              {
                fprintf (stderr, "%s: `--ipc' option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
                goto failure;
              }
            if (args_info->ipc_given && ! override)
              continue;
            local_args_info.ipc_given = 1;
            args_info->ipc_given = 1;
            args_info->ipc_flag = !(args_info->ipc_flag);
          }
          /* New user namespace.  */
          else if (strcmp (long_options[option_index].name, "userns") == 0)
          {
            if (local_args_info.userns_given)
              {
                fprintf (stderr, "%s: `--userns' option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
                goto failure;
              }
            if (args_info->userns_given && ! override)
              continue;
            local_args_info.userns_given = 1;
            args_info->userns_given = 1;
            args_info->userns_flag = !(args_info->userns_flag);
          }
          /* New PID namespace.  */
          else if (strcmp (long_options[option_index].name, "pidns") == 0)
          {
            if (local_args_info.pidns_given)
              {
                fprintf (stderr, "%s: `--pidns' option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
                goto failure;
              }
            if (args_info->pidns_given && ! override)
              continue;
            local_args_info.pidns_given = 1;
            args_info->pidns_given = 1;
            args_info->pidns_flag = !(args_info->pidns_flag);
          }
          /* New network namespace.  */
          else if (strcmp (long_options[option_index].name, "netns") == 0)
          {
            if (local_args_info.netns_given)
              {
                fprintf (stderr, "%s: `--netns' option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
                goto failure;
              }
            if (args_info->netns_given && ! override)
              continue;
            local_args_info.netns_given = 1;
            args_info->netns_given = 1;
            args_info->netns_flag = !(args_info->netns_flag);
          }
          /* Pass user defined flag.  */
          else if (strcmp (long_options[option_index].name, "mask") == 0)
          {
            local_args_info.mask_given++;
          
            multi_token = get_multiple_arg_token(optarg);
            multi_next = get_multiple_arg_token_next (optarg);
          
            while (1)
              {
                mask_new = (struct int_list *) malloc (sizeof (struct int_list));
                mask_new->next = mask_list;
                mask_list = mask_new;
                mask_new->arg = strtol (multi_token, &stop_char, 0);
                if (!(stop_char && *stop_char == '\0')) {
                  fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], multi_token);
                  goto failure;
                }
                mask_new->orig = multi_token;
          
                if (multi_next)
                  {
                    multi_token = get_multiple_arg_token(multi_next);
                    multi_next = get_multiple_arg_token_next (multi_next);
                    local_args_info.mask_given++;
                  }
                else
                  break;
              }
            break;
          }
          /* Chroot in the specified directory.  */
          else if (strcmp (long_options[option_index].name, "chroot") == 0)
          {
            if (local_args_info.chroot_given)
              {
                fprintf (stderr, "%s: `--chroot' option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
                goto failure;
              }
            if (args_info->chroot_given && ! override)
              continue;
            local_args_info.chroot_given = 1;
            args_info->chroot_given = 1;
            if (args_info->chroot_arg)
              free (args_info->chroot_arg); /* free previous string */
            args_info->chroot_arg = gengetopt_strdup (optarg);
            if (args_info->chroot_orig)
              free (args_info->chroot_orig); /* free previous string */
            args_info->chroot_orig = gengetopt_strdup (optarg);
          }
          /* Change to the specified UID.  */
          else if (strcmp (long_options[option_index].name, "uid") == 0)
          {
            if (local_args_info.uid_given)
              {
                fprintf (stderr, "%s: `--uid' option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
                goto failure;
              }
            if (args_info->uid_given && ! override)
              continue;
            local_args_info.uid_given = 1;
            args_info->uid_given = 1;
            args_info->uid_arg = strtol (optarg, &stop_char, 0);
            if (!(stop_char && *stop_char == '\0')) {
              fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
              goto failure;
            }
            if (args_info->uid_orig)
              free (args_info->uid_orig); /* free previous string */
            args_info->uid_orig = gengetopt_strdup (optarg);
          }
          /* Change to the specified username.  */
          else if (strcmp (long_options[option_index].name, "username") == 0)
          {
            if (local_args_info.username_given)
              {
                fprintf (stderr, "%s: `--username' option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
                goto failure;
              }
            if (args_info->username_given && ! override)
              continue;
            local_args_info.username_given = 1;
            args_info->username_given = 1;
            if (args_info->username_arg)
              free (args_info->username_arg); /* free previous string */
            args_info->username_arg = gengetopt_strdup (optarg);
            if (args_info->username_orig)
              free (args_info->username_orig); /* free previous string */
            args_info->username_orig = gengetopt_strdup (optarg);
          }
          /* Add the specified GID.  */
          else if (strcmp (long_options[option_index].name, "gid") == 0)
          {
            local_args_info.gid_given++;
          
            multi_token = get_multiple_arg_token(optarg);
            multi_next = get_multiple_arg_token_next (optarg);
          
            while (1)
              {
                gid_new = (struct int_list *) malloc (sizeof (struct int_list));
                gid_new->next = gid_list;
                gid_list = gid_new;
                gid_new->arg = strtol (multi_token, &stop_char, 0);
                if (!(stop_char && *stop_char == '\0')) {
                  fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], multi_token);
                  goto failure;
                }
                gid_new->orig = multi_token;
          
                if (multi_next)
                  {
                    multi_token = get_multiple_arg_token(multi_next);
                    multi_next = get_multiple_arg_token_next (multi_next);
                    local_args_info.gid_given++;
                  }
                else
                  break;
              }
            break;
          }
          /* Add the specified group.  */
          else if (strcmp (long_options[option_index].name, "groupname") == 0)
          {
            local_args_info.groupname_given++;
          
            multi_token = get_multiple_arg_token(optarg);
            multi_next = get_multiple_arg_token_next (optarg);
          
            while (1)
              {
                groupname_new = (struct string_list *) malloc (sizeof (struct string_list));
                groupname_new->next = groupname_list;
                groupname_list = groupname_new;
                groupname_new->arg = gengetopt_strdup (multi_token);
                groupname_new->orig = multi_token;
          
                if (multi_next)
                  {
                    multi_token = get_multiple_arg_token(multi_next);
                    multi_next = get_multiple_arg_token_next (multi_next);
                    local_args_info.groupname_given++;
                  }
                else
                  break;
              }
            break;
          }
          /* Run as daemon.  */
          else if (strcmp (long_options[option_index].name, "daemonize") == 0)
          {
            if (local_args_info.daemonize_given)
              {
                fprintf (stderr, "%s: `--daemonize' option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
                goto failure;
              }
            if (args_info->daemonize_given && ! override)
              continue;
            local_args_info.daemonize_given = 1;
            args_info->daemonize_given = 1;
            args_info->daemonize_flag = !(args_info->daemonize_flag);
          }
          /* Set an alarm after the specified delay.  */
          else if (strcmp (long_options[option_index].name, "alarm") == 0)
          {
            if (local_args_info.alarm_given)
              {
                fprintf (stderr, "%s: `--alarm' option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
                goto failure;
              }
            if (args_info->alarm_given && ! override)
              continue;
            local_args_info.alarm_given = 1;
            args_info->alarm_given = 1;
            args_info->alarm_arg = strtol (optarg, &stop_char, 0);
            if (!(stop_char && *stop_char == '\0')) {
              fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
              goto failure;
            }
            if (args_info->alarm_orig)
              free (args_info->alarm_orig); /* free previous string */
            args_info->alarm_orig = gengetopt_strdup (optarg);
          }
          /* Run as the specified nice level.  */
          else if (strcmp (long_options[option_index].name, "nice") == 0)
          {
            if (local_args_info.nice_given)
              {
                fprintf (stderr, "%s: `--nice' option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
                goto failure;
              }
            if (args_info->nice_given && ! override)
              continue;
            local_args_info.nice_given = 1;
            args_info->nice_given = 1;
            args_info->nice_arg = strtol (optarg, &stop_char, 0);
            if (!(stop_char && *stop_char == '\0')) {
              fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
              goto failure;
            }
            if (args_info->nice_orig)
              free (args_info->nice_orig); /* free previous string */
            args_info->nice_orig = gengetopt_strdup (optarg);
          }
          /* Use the specified (possibly RT) scheduling policy.  */
          else if (strcmp (long_options[option_index].name, "sched") == 0)
          {
            if (local_args_info.sched_given)
              {
                fprintf (stderr, "%s: `--sched' option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
                goto failure;
              }
            if (args_info->sched_given && ! override)
              continue;
            local_args_info.sched_given = 1;
            args_info->sched_given = 1;
            if (args_info->sched_arg)
              free (args_info->sched_arg); /* free previous string */
            args_info->sched_arg = gengetopt_strdup (optarg);
            if (args_info->sched_orig)
              free (args_info->sched_orig); /* free previous string */
            args_info->sched_orig = gengetopt_strdup (optarg);
          }
          /* Set the priority according to the given scheduler.  */
          else if (strcmp (long_options[option_index].name, "schedprio") == 0)
          {
            if (local_args_info.schedprio_given)
              {
                fprintf (stderr, "%s: `--schedprio' option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
                goto failure;
              }
            if (args_info->schedprio_given && ! override)
              continue;
            local_args_info.schedprio_given = 1;
            args_info->schedprio_given = 1;
            args_info->schedprio_arg = strtol (optarg, &stop_char, 0);
            if (!(stop_char && *stop_char == '\0')) {
              fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
              goto failure;
            }
            if (args_info->schedprio_orig)
              free (args_info->schedprio_orig); /* free previous string */
            args_info->schedprio_orig = gengetopt_strdup (optarg);
          }
          /* Delay before sending a SIGTERM to the process.  */
          else if (strcmp (long_options[option_index].name, "timeout-term") == 0)
          {
            if (local_args_info.timeout_term_given)
              {
                fprintf (stderr, "%s: `--timeout-term' option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
                goto failure;
              }
            if (args_info->timeout_term_given && ! override)
              continue;
            local_args_info.timeout_term_given = 1;
            args_info->timeout_term_given = 1;
            args_info->timeout_term_arg = strtod (optarg, &stop_char);
            if (!(stop_char && *stop_char == '\0')) {
              fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
              goto failure;
            }
            if (args_info->timeout_term_orig)
              free (args_info->timeout_term_orig); /* free previous string */
            args_info->timeout_term_orig = gengetopt_strdup (optarg);
          }
          /* Delay before sending a SIGKILL to the process.  */
          else if (strcmp (long_options[option_index].name, "timeout-kill") == 0)
          {
            if (local_args_info.timeout_kill_given)
              {
                fprintf (stderr, "%s: `--timeout-kill' option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
                goto failure;
              }
            if (args_info->timeout_kill_given && ! override)
              continue;
            local_args_info.timeout_kill_given = 1;
            args_info->timeout_kill_given = 1;
            args_info->timeout_kill_arg = strtod (optarg, &stop_char);
            if (!(stop_char && *stop_char == '\0')) {
              fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
              goto failure;
            }
            if (args_info->timeout_kill_orig)
              free (args_info->timeout_kill_orig); /* free previous string */
            args_info->timeout_kill_orig = gengetopt_strdup (optarg);
          }
          
          break;
        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          goto failure;

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c%s\n", CMDLINE_PARSER_PACKAGE, c, (additional_error ? additional_error : ""));
          abort ();
        } /* switch */
    } /* while */


  if (local_args_info.mask_given && mask_list)
    {
      struct int_list *tmp;
      args_info->mask_arg = (int *) realloc (args_info->mask_arg, (args_info->mask_given + local_args_info.mask_given) * sizeof (int));
      args_info->mask_orig = (char **) realloc (args_info->mask_orig, (args_info->mask_given + local_args_info.mask_given) * sizeof (char *));
      for (i = (local_args_info.mask_given - 1); i >= 0; --i)
        {
          tmp = mask_list;
          args_info->mask_arg [i + args_info->mask_given] = mask_list->arg;
          args_info->mask_orig [i + args_info->mask_given] = mask_list->orig;
          mask_list = mask_list->next;
          free (tmp);
        }
    }
  
  if (local_args_info.gid_given && gid_list)
    {
      struct int_list *tmp;
      args_info->gid_arg = (int *) realloc (args_info->gid_arg, (args_info->gid_given + local_args_info.gid_given) * sizeof (int));
      args_info->gid_orig = (char **) realloc (args_info->gid_orig, (args_info->gid_given + local_args_info.gid_given) * sizeof (char *));
      for (i = (local_args_info.gid_given - 1); i >= 0; --i)
        {
          tmp = gid_list;
          args_info->gid_arg [i + args_info->gid_given] = gid_list->arg;
          args_info->gid_orig [i + args_info->gid_given] = gid_list->orig;
          gid_list = gid_list->next;
          free (tmp);
        }
    }
  
  if (local_args_info.groupname_given && groupname_list)
    {
      struct string_list *tmp;
      args_info->groupname_arg = (char * *) realloc (args_info->groupname_arg, (args_info->groupname_given + local_args_info.groupname_given) * sizeof (char *));
      args_info->groupname_orig = (char **) realloc (args_info->groupname_orig, (args_info->groupname_given + local_args_info.groupname_given) * sizeof (char *));
      for (i = (local_args_info.groupname_given - 1); i >= 0; --i)
        {
          tmp = groupname_list;
          args_info->groupname_arg [i + args_info->groupname_given] = groupname_list->arg;
          args_info->groupname_orig [i + args_info->groupname_given] = groupname_list->orig;
          groupname_list = groupname_list->next;
          free (tmp);
        }
    }
  

  args_info->mask_given += local_args_info.mask_given;
  local_args_info.mask_given = 0;
  args_info->gid_given += local_args_info.gid_given;
  local_args_info.gid_given = 0;
  args_info->groupname_given += local_args_info.groupname_given;
  local_args_info.groupname_given = 0;
  
  if (check_required)
    {
      error += cmdline_parser_required2 (args_info, argv[0], additional_error);
    }

  cmdline_parser_release (&local_args_info);

  if ( error )
    return (EXIT_FAILURE);

  if (optind < argc)
    {
      int i = 0 ;
      int found_prog_name = 0;
      /* whether program name, i.e., argv[0], is in the remaining args
         (this may happen with some implementations of getopt,
          but surely not with the one included by gengetopt) */

      i = optind;
      while (i < argc)
        if (argv[i++] == argv[0]) {
          found_prog_name = 1;
          break;
        }
      i = 0;

      args_info->inputs_num = argc - optind - found_prog_name;
      args_info->inputs =
        (char **)(malloc ((args_info->inputs_num)*sizeof(char *))) ;
      while (optind < argc)
        if (argv[optind++] != argv[0])
          args_info->inputs[ i++ ] = gengetopt_strdup (argv[optind-1]) ;
    }

  return 0;

failure:
  if (mask_list)
    {
      struct int_list *tmp;
      while (mask_list)
        {
          tmp = mask_list;
          free (mask_list->orig);
          mask_list = mask_list->next;
          free (tmp);
        }
    }
  if (gid_list)
    {
      struct int_list *tmp;
      while (gid_list)
        {
          tmp = gid_list;
          free (gid_list->orig);
          gid_list = gid_list->next;
          free (tmp);
        }
    }
  if (groupname_list)
    {
      struct string_list *tmp;
      while (groupname_list)
        {
          tmp = groupname_list;
          free (groupname_list->arg);
          free (groupname_list->orig);
          groupname_list = groupname_list->next;
          free (tmp);
        }
    }
  
  cmdline_parser_release (&local_args_info);
  return (EXIT_FAILURE);
}
